\documentclass[10pt,letterpaper]{article}
\usepackage{fullpage}
\usepackage{svg}
\usepackage{float}
\usepackage{hyperref}


\begin{document}
	\title{\textbf{CMSC6950 Project Report\\ Analysing Bank Marketing Data}}
	\author{\\ \\ \\By \\ Kratika Naskulwar \\ Praveena Pinnika \\ Jewel Mahmud Nimul Shamim \\ Bhumi Tailor\\ \\ \\ \\ Master of Science(MSc) \\ Memorial University of Newfoundland}
	\date{June 2019 }
	\maketitle
	
	\begin{abstract}
	 This project is about developing a computational workflow to solve a scientific problem using a few scientific libraries and software. The goal is to analyze the bank marketing data to find out the impact of age, job, loan, duration and marital status, etc on the subscription of a bank product (term deposit) by customers. To achieve this, we build a reproducible computational workflow using required scientific computing libraries and software e.g. python plots, pytest and, gitlab etc, that help us visualize and analyze the data.
		
		\paragraph{Keywords :}
		Data analysis, pyplots, unit testing, git, visualization
		
	\end{abstract}
	
	\newpage
	\tableofcontents
	\listoffigures
	\listoftables
	
	\newpage
	\section{Introduction}
	Often some part of the scientific workflow depends on the computer. Researchers use computers to find the data, analyze it and find some meaningful results. Computers are vital to accomplish and automate nearly any aspect of research. Data analysis is one of the main aspects of the research, it is a process where data is inspected, cleansed, modeled and, transformed in order to extract the useful details and information out of data in several decision-making tasks. There are different approaches for data analysis and it plays an important role in decision making in scientific problems and other domains.\par
	
	This paper presents a computational workflow of a scientific problem. The dataset \cite{ref1} used for this project is referred from UCI machine learning repository. The data is associated with direct marketing campaigns of a Portuguese banking organization from May 2008 to November 2010. The campaigns were driven through phone calls. The problem is to find the impact of multiple attributes of a bank's customer data on buying the bank's product by its customers. The attributes are age, job, marital status, average yearly balance, housing loan and, number of times the customer was contacted for the product. The bank's product is the Term Deposit. We used different scientific computing libraries and software to accomplish the goal. We used python3 \cite{ref2} , pyplots \cite{ref3}, numpy \cite{ref4}, pandas \cite{ref5},unit testing using pytest \cite{ref6}, version control (git) \cite{ref7}, markdown \cite{ref8} for readme file, collaboration tools (GitLab), remark-js library \cite{ref9} for web-based presentation.
		
	
	\section{Methodology}
	 The dataset used for this project was taken from the UCI repository. The data belongs to a Portuguese banking organization from 2008 to 2010.  The data is associated with a direct marketing campaign.  The raw data has 17 features/attributes named as age, job, marital, education, default, balance, housing, loan, contact, day, month, duration, campaign, campaign, previous, poutcome, and, y. The 'y' is the term deposit of the bank. The data suggest if the customer subscribed for term deposit or not. The scripts for this project are written in Python language. \par
	The dataset used for this project can be accessed from \cite{ref1}. The complete project along with all the codes and documentation is hosted on gitlab and can be accessed from \cite{ref10}.
	
	\subsection{Download data}
	The first step to building the project is to download the required dataset from the web. The file 'download.py' is for automatically downloading data from the UCI repository. It uses requests, ZipFile, and argparse modules. It takes three command line arguments URL, zip file to be downloaded and the particular file to be extracted from the zip file. It fetches and downloads the 'bank.csv' file as well as the bank.zip file in the current folder. The downloaded data has 17 columns and 4521 rows.  \par
	Raw Data specifications: \par
	Download data file name - bank.csv \par
	Number of data points  - 4521 \par
	Number of attributes - 17
	
	\subsection{Histogram plots}
	For visualization of the raw data. We plotted histograms \cite{ref11} of the numerical attributes from the raw data. The numerical attributes in raw data are age, balance, duration, previous, pdays and, campaign. A histogram is a bar plot used to plot numerical data and group the data into bins. The matplotlib.pyplot module was used to plot the histograms. The file 'histogram.py'  is for plotting the histograms and it takes no command line arguments. Below are the histograms for 6 numerical attributes.
	
	\begin{figure}[H]
		\centering
		\begin{minipage}{0.45\textwidth}
			\centering
			\includegraphics[width=0.9\textwidth]{histograms/age} 
			\caption{histogram plot for age}
		\end{minipage}\hfill
		\begin{minipage}{0.45\textwidth}
			\centering
			\includegraphics[width=0.9\textwidth]{histograms/balance}
			\caption{histogram plot for balance}
		\end{minipage}
	\end{figure}
	
	\begin{figure}[H]
		\centering
		\begin{minipage}{0.45\textwidth}
			\centering
			\includegraphics[width=0.9\textwidth]{histograms/duration} 
			\caption{histogram plot duration}
		\end{minipage}\hfill
		\begin{minipage}{0.45\textwidth}
			\centering
			\includegraphics[width=0.9\textwidth]{histograms/previous}
			\caption{histogram plot for previous}
		\end{minipage}
	\end{figure}
	
	\begin{figure}[H]
		    \centering
		\begin{minipage}{0.45\textwidth}
			\centering
			\includegraphics[width=0.9\textwidth]{histograms/campaign} 
			\caption{histogram plot for campaign}
		\end{minipage}\hfill
		\begin{minipage}{0.45\textwidth}
			
		\end{minipage}
	\end{figure}
	\newpage
	\subsection{Clean data}
	The next step is to clean the raw data to get the data with the required specifications. In order for data to be more clear and useful, the data is processed and cleaned in this step. The file 'cleandata.py' is to get the clean version from the raw data. Running this script generates the 'ProcessedBankData.csv' file in the current folder and takes the 'bank-full.csv' file as the input obtained from the download data step from the current folder. It takes no command line arguments. \par
	
	In this step, first, the columns that were not required were dropped. The number of columns dropped is 10. The attributes with string values were converted to integer in order to see the type of data we have. There was no missing data. The column labels were renamed to have a better understanding of the attributes and the duplicates were removed. Below is the processed data details in Table 1 and Table 2. \par 
	Processed Data specifications: \par
	Number of data points  - 4500 \par
	Number of attributes - 7 \par
	
	\begin{table}[H]
		\centering
		\caption{Feature values before and after changing}
		\begin{tabular}{|l|l|l|}
			\hline
			Feature Label & String values : before changing                                                                                                                                                        & Integer values : after changing                                                          \\ \hline
			job           & \begin{tabular}[c]{@{}l@{}}admin\\ blue-collar\\ entrepreneur\\ housemaid\\ management\\ retired\\ self-employed\\ services\\ student\\ technician\\ unemployed\\ unknown\end{tabular} & \begin{tabular}[c]{@{}l@{}}1\\ 2\\ 3\\ 4\\ 5\\ 6\\ 7\\ 8\\ 9\\ 10\\ 11\\ 12\end{tabular} \\ \hline
			marital       & \begin{tabular}[c]{@{}l@{}}married\\ single\\ divorced\end{tabular}                                                                                                                    & \begin{tabular}[c]{@{}l@{}}1\\ 2\\ 3\end{tabular}                                        \\ \hline
			housing       & \begin{tabular}[c]{@{}l@{}}yes\\ no\end{tabular}                                                                                                                                       & \begin{tabular}[c]{@{}l@{}}1\\ 0\end{tabular}                                            \\ \hline
			y             & \begin{tabular}[c]{@{}l@{}}yes\\ no\end{tabular}                                                                                                                                       & \begin{tabular}[c]{@{}l@{}}1\\ 0\end{tabular}                    \\ \hline                       
		\end{tabular}
	\end{table}
	
	\begin{table}[H]
		\centering
		\caption{Renamed feature labels}
		\begin{tabular}{|l|l|l|}
			\hline
			Original Feature label & New feature label                  \\ \hline
			age                    & Age                                \\ \hline
			job                    & Job                                \\ \hline
			marital                & Marital Status                     \\ \hline
			balance                & Avg yearly balance                 \\ \hline
			housing                & Housing Loan                       \\ \hline
			campaign               & \# of times customer was contacted \\ \hline
			y                      & Term deposit subscription          \\ \hline
		\end{tabular}
	\end{table}
	
	\subsection{Univariate Plot}
	Univariate \cite{ref12} plot gives a more concise expression of the location, dispersion, and distribution of a variable.Box plot and Dot plots gives the visual representation of behavior of each variable.Univariate plots show how large or small the values of individual observations are,the scale of the variables and  frequency of occurrence of different values of the variables.
	
	\subsubsection{Dot Plot}
	Dot plots show changes between the two conditions. Dot plots show a relation between various attributes from Bank database to that of Term deposit subscription. The file 'Plot\_Dot.py' is for plotting the dot plots for each attribute, Age, Job, Avg yearly balance and, number of times customer was contacted from the processed data, each against Term deposit subscription. Figure 7 shows the dot plots.\par
	The dot plots show that variable age has a similar impact on whether a customer bought term deposit or not. like Avg yearly balance. 
		
	\begin{figure}[H]
		\centering
		\includegraphics[width=0.5\columnwidth]{Plot_Dot}
		\caption{Dot plots}
	\end{figure}
	
	\subsubsection{Box Plot}
	Box plot makes a box and a whisker plot for each column of an attribute. The file 'Plot\_Box.py' is for plotting the box plots for Age, Job, Avg yearly balance and, the number of times customer was contacted from the processed data. Figure 8 shows the box plots.\par
	
	The box plots show that customer with job status with(8,9,10,11, that is student, unemployed, unknown) did not buy the term deposit. In case of age, most of the customers with age between 30 to 50 have bought the term deposit, however, as you go beyond 50-55, the number of customers having term deposits is less.
	
	\begin{figure}[H]
		\centering
		\includegraphics[width=0.5\columnwidth]{Plot_Box}
		\caption{Box plots}
	\end{figure}
	
	\subsection{Multivariate Plot}
	Multivariate plots show the relationship among numerous features concurrently. There are various basic properties of the relationship between sets of features of interest. The multivariate plots imply the form and the strength of the relationships among the attributes. There are many types of multivariate plots. In this project, we are using piechart and bar diagram to plot multivariate plot using bokeh module \cite{ref13}.
	
	\subsubsection{Piechart}
	Pie Chart analyzes the relationship between attributes from Bank database. It will take three attributes age, house loan, and their term deposit. It takes the age interval starting from 20 to 25 and ends with 90 to 95 and check who have house loan and term deposit. It checks the relationship and finds out which age group people have more house loan and term deposit.  Figure 8 shows the dot plots.
	
	\begin{figure}[H]
		\centering
		\includegraphics[width=0.5\columnwidth]{piechart.jpg}
		\caption{Pie Chart}
	\end{figure}
	
	\subsubsection{Bar diagram}
	Bar Diagram analyzes the relationship between attributes from Bank database. It will take three attributes age, jobs and their average yearly balance. It takes the age interval starting from 20 to 25 and ends with 90 to 95 and check which group of people and job holders have more yearly balance. Figure 9 shows the dot plots.
	
	\begin{figure}[H]
		\centering
		\includegraphics[width=0.5\columnwidth]{bardiag.jpg}
		\caption{Bar Diagram}
	\end{figure}
	
	\subsection{Virtual Environment}
	Pipenv \cite{ref14} is a production-ready tool that aims to bring the best of all packaging worlds to the Python world.
	we used pipenv lock to compile the dependencies on your development environment and deploy the compiled Pipfile.lock to all of your production environments for reproducible builds.
	
	\subsection{Unit Testing}
	   In the UnitTest.py file, we test the component of the application. The main purpose of this unittets.py file is to check that every file is generated perfectly or not. After running the makefile, makefile downloads bank.zip, bank.csv and also clean data generate the ProcessedBankData.csv.checkBankCSVandZip() and checkProcessData() function check those file generated or not.Histogram.py file generate histograms in the histogram directory. checkHistogramDir() function check the directory exist and generated.Plotbox.py and plotdot.py generate two image file.. checkPlotFiles() check both plotbox and plotdot image files pieDiagram.py barDiagram.py generate two html file. checkBarandPieDiagram() function will check those file are generated by this function.
    
	\subsection{Makefile}
	Make \cite{ref15} is a simple way to organize the codes and to make a project reproducible easily. It contains all the scripts required to get a goal or target. It has targets and dependencies. In this project, makefile produces the entire project at once without having to run each code individually. The file name is Makefile. To reproduce this project run one of the two commands, simply 'make' or 'make -f <makefile name>' from the command line. Run 'make clean' to clean the existing targets. 
	
	\subsection{Readme File for gitlab}
	 The Readme file contains all the steps and instruction on how to build and use the project step by step, it is a user guide. Readme file in gitlab can be referred for all the instructions and a user guide for this project through this link.  \href{https://gitlab.com/cmsc6950/team3/analysing-bank-marketing-data/blob/master/README.md}{Readme file link} 
	
	\section{Results}
	Our analysis shows that the highest number of people subscribed for term deposits belong to 35 to 40 years age group and the customers from the same age group have more house loans too. The least number of term deposits are subscribed by the 80-85 age group. From the histograms plotted from raw data shows that the bank has contacted more people having age between 35 to 40 years. Therefore, more number of people contacted by bank and more number of people subscribed for the term deposit belong to the same age group.
	
	\section{Conclusion}
	This analysis highlights the effect of different attributes of bank marketing data on term deposit subscription. The raw data downloaded from the website has represented visually by plotting histograms for numerical fields which gives the basic idea of customer information. For better analysis raw data was cleaned by truncating unnecessary fields and data type conversions. Each attribute behavior has explained with univariate plots on cleaned data. Relationships between attributes are represented using multivariate plots on cleaned data. The compilation of project and generation of required reports has automated using makefile and test suits are written to check the correct functionality of code.pipenv is applied to compile dependencies on the development environment. 
	
	\begin{thebibliography}{30}
		\addcontentsline{toc}{section}{References}
		\bibitem{ref1} 
		S. Moro, P. Cortez and P. Rita. A Data-Driven Approach to Predict the Success of Bank Telemarketing. Decision Support Systems, Elsevier, 62:22-31, (2014)
		
		\bibitem{ref2} 
		Python Core Team . Python: A dynamic, open source programming 
		language. Python Software Foundation. URL https://www.python.org/, (2015)
		
		\bibitem{ref3} 
		J. D. Hunter, "Matplotlib: A 2D Graphics Environment", Computing in Science \& Engineering, vol. 9, no. 3, pp. 90-95, (2007)
		
		\bibitem{ref4} 
		Oliphant TE. A guide to NumPy. Vol. 1. Trelgol Publishing USA; (2006)
		
		\bibitem{ref5}
		Wes McKinney. Data Structures for Statistical Computing in Python, Proceedings of the 9th Python in Science Conference, 51-56, (2010)
		
		\bibitem{ref6}
		Okken, B. Python testing with Pytest: Simple, rapid, effective, and scalable,  (2017)
		
		\bibitem{ref7}
		Chacon, Scott, and Ben Straub. Pro Git. Apress, (2019)
		
		\bibitem{ref8}
		Wikipedia contributors. "Markdown." Wikipedia, The Free Encyclopedia. Wikipedia, The Free Encyclopedia, 13 Jun. 2019. Web. (2019)
		
		\bibitem{ref9}
		A simple, in-browser, markdown-driven slideshow tool. http://remarkjs.com
		
		\bibitem{ref10}
		Analysing bank marketing data, https://gitlab.com/cmsc6950/team3/analysing-bank-marketing-data, (2019)
		
		\bibitem{ref11} 
		Histogram in Matplotlib;.Available from: Matplotlib Histogram;.Available from: https://pythonspot.com/matplotlib-histogram
		
		\bibitem{ref12}
		Univariate plotting with pandas;.Available from: https://www.kaggle.com/residentmario/univariate-plotting-with-pandas
		
		\bibitem{ref13}
		Introduction to bokeh;.Available from: https://zapcircle.net/introduction-to-bokeh/
		
		\bibitem{ref14} 
		Pipenv: A Guide to the New Python Packaging Tool;.Available from: https://realpython.com/pipenv-guide/\#the-pipfile
		
		\bibitem{ref15} 
		A Simple Makefile Tutorial;.Available from: http://www.cs.colby.edu/maxwell/courses/tutorials/maketutor/
	
\end{thebibliography}
	
\end{document}

